org.apache.sysds.runtime.compress.estim

## Class CompressedSizeEstimatorUltraSparse

- java.lang.Object
- - org.apache.sysds.runtime.compress.estim.CompressedSizeEstimator
  - - org.apache.sysds.runtime.compress.estim.CompressedSizeEstimatorUltraSparse

    public class CompressedSizeEstimatorUltraSparse
    extends CompressedSizeEstimator

UltraSparse compressed size estimator (examines entire dataset).

### Method Summary

All Methods Instance Methods Concrete Methods
`CompressedSizeInfoColGroup` `estimateCompressedColGroupSize(int[] colIndexes, int estimate, int nrUniqueUpperBound)` A method to extract the Compressed Size Info for a given list of columns, This method further limits the estimated number of unique values, since in some cases the estimated number of uniques is estimated higher than the number estimated in sub groups of the given colIndexes.

### Methods inherited from class org.apache.sysds.runtime.compress.estim.CompressedSizeEstimator

`computeCompressedSizeInfos, computeCompressedSizeInfos, computeCompressedSizeInfos, estimateCompressedColGroupSize, estimateCompressedColGroupSize, estimateCompressedColGroupSize, estimateCompressedColGroupSize, estimateJoinCompressedSize, estimateJoinCompressedSize, getData, getNumColumns, getNumRows`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### estimateCompressedColGroupSize

    public CompressedSizeInfoColGroup estimateCompressedColGroupSize(int[] colIndexes,
                                                                     int estimate,
                                                                     int nrUniqueUpperBound)

Description copied from class: `CompressedSizeEstimator`
A method to extract the Compressed Size Info for a given list of columns, This method further limits the estimated number of unique values, since in some cases the estimated number of uniques is estimated higher than the number estimated in sub groups of the given colIndexes.

Specified by:
  `estimateCompressedColGroupSize` in class `CompressedSizeEstimator`
Parameters:
  `colIndexes` - The columns to extract compression information from
  `estimate` - An estimate of number of unique elements in these columns
  `nrUniqueUpperBound` - The upper bound of unique elements allowed in the estimate, can be calculated from the number of unique elements estimated in sub columns multiplied together. This is flexible in the sense that if the sample is small then this unique can be manually edited like in CoCodeCostMatrixMult.
Returns:
  The CompressedSizeInfoColGroup fro the given column indexes.